<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.16 Update #2                                        |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2012 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.97.120908-140829                                              |
// +--------------------------------------------------------------------------+

error_reporting( 0 );
/**
 * @package Contentteller
 * @copyright (C) 2002-2012 Esselbach Internet Solutions
 */

/**
 * Contentteller module loader/wrapper
 * @author Philipp Louis Esselbach
 */

//---------------------------------------------
// Not installed? Redirect to installer
//---------------------------------------------

if( !file_exists( "includes/build.php" ) )
{
	header( "location: cadmin/cinstall.php" );
}

//---------------------------------------------
// Unset and define variables
//---------------------------------------------

unset( $config, $ct, $action, $id, $opt, $ipaddr, $user, $preferences );
define( "CONTENTTELLER", 1 );

//---------------------------------------------
// Check memory limit
//---------------------------------------------

$memory_limit = str_replace( "M", "", ini_get( "memory_limit" ) );

if ( $memory_limit < 128 )
{
	@ini_set( "memory_limit", "128M" );
}

//---------------------------------------------
// Load classes
//---------------------------------------------

include( "includes/config.php" );
include( "classes/class_db_" . $config[ 'DB_LAYER' ] . ".php" );
$database = new database;
include( "classes/class_templates.php" );
include( "classes/class_security.php" );
include( "classes/class_system.php" );
$templates = new templates;
$system = new system;
$security = new security;

//---------------------------------------------
// Define main settings
//---------------------------------------------

if( !isset( $config[ 'DB_ENGINE' ] ) )
{
	$config[ 'DB_ENGINE' ] = "MyISAM";
}
define( "DB_PREFIX", $security -> localcheckvare( $config[ 'DB_PREFIX' ] ) );
define( "DB_ENGINE", $security -> localcheckvare( $config[ 'DB_ENGINE' ] ) );
define( "MAIN_MODULE", $security -> localcheckvare( $config[ 'MAIN_MODULE' ] ) );
define( "DEFAULT_THEME", $security -> localcheckvare( $config[ 'DEFAULT_THEME' ] ) );

//---------------------------------------------
// Check whether the preferences are cached
//---------------------------------------------

if( $config[ 'CACHE_PREFERENCES' ] )
{
	if( file_exists( "includes/preferences.php" ) )
	{
		include( "includes/preferences.php" );
	}
}

//---------------------------------------------
// Connect to the CMS database
//---------------------------------------------

$database -> dbconnect();

//---------------------------------------------
// Get preferences from the database
//---------------------------------------------

if( !isset( $preferences ) )
{
	$preferences = array();
	$query = $database -> dbquery( "SELECT preference_key, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_website = '0' OR preference_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );

	while( list( $preference_key, $preference_value ) = $database -> dbrow( $query ) )
	{
		$preference_key = strtolower( $preference_key );
		$preferences[ $preference_key ] = $preference_value;
	}

	if( $config[ 'CACHE_PREFERENCES' ] )
	{
		$preferences_conf = "\$preferences = array(\n\n";
		$preferences_keys = array_keys( $preferences );

		for( $i = 0; $i < count( $preferences ); $i++ )
		{
			$preferences_conf .= "\"" . $preferences_keys[ $i ] . "\" => \"" . addslashes( $preferences[ $preferences_keys[ $i ] ] ) . "\",\n";
		}

		$preferences_conf .= "\n);";
		$cachefile = @fopen( "includes/preferences.php", "w" ) or die( "Error: Can't write includes/preferences.php cache file" );

		if( flock( $cachefile, 2 ) )
		{
			fputs( $cachefile, "<?php\n\n" . $preferences_conf . "\n\n?>" );
		}

		flock( $cachefile, 3 );
		fclose( $cachefile );
	}
}

//---------------------------------------------
// First run? Redirect to the admin section
//---------------------------------------------

if( !$preferences[ 'product_firstrun' ] )
{
	header( "location: cadmin/" );
	exit;
}

//---------------------------------------------
// Set and get variables
//---------------------------------------------

$preferences[ 'website_cache_running' ] = 0;

$system -> init( 0 );
$uwrapper = new uwrapper;

if( $preferences[ 'website_charset' ] == "UTF-8" )
{
	$preferences[ 'website_locale' ] .= ".utf8";
}
@setlocale( LC_ALL, $preferences[ 'website_locale' ] );

$ct = ( isset( $_GET[ 'ct' ] ) ) ? $security -> checkvare( $_GET[ 'ct' ] ): "" ;
$action = ( isset( $_GET[ 'action' ] ) ) ? $security -> checkvar( $_GET[ 'action' ] ) : "" ;
$id = ( isset( $_GET[ 'id' ] ) ) ? $security -> checknum( $_GET[ 'id' ] ) : "" ;
$page = ( isset( $_GET[ 'page' ] ) ) ? $security -> checkvar( $_GET[ 'page' ] ) : "" ;
$opt = ( isset( $_GET[ 'opt' ] ) )? $security -> checkvar( $_GET[ 'opt' ] ): "" ;
$ipaddr = $system -> getip();
$user = $uwrapper -> init();

//---------------------------------------------
// Get selected theme
//---------------------------------------------

if( ( isset( $_COOKIE[ 'esselbachctt' ] ) ) and( $preferences[ 'website_theme_override' ] ) )
{
	$theme = $security -> checknum( $_COOKIE[ 'esselbachctt' ] );
	$query = $database -> dbquery( "SELECT templateset_name FROM " . DB_PREFIX . "esselbach_ct_templatesets WHERE templateset_id = '" . $theme . "'" );

	if( !$database -> dbrows( $query ) )
	{
		setcookie( $preferences[ 'website_uwrapper_cookieprefix' ] . "esselbachctt", 0, mktime()-3600, $preferences[ 'website_uwrapper_cookiepath' ], $preferences[ 'website_uwrapper_cookiedomain' ] ) ;
		$theme = DEFAULT_THEME;
	}
}
else
{
	$theme = DEFAULT_THEME;
}

$preferences[ 'current_theme' ] = $theme;

//---------------------------------------------
// Get current website
//---------------------------------------------

$preferences[ 'current_website' ] = intval( $config[ 'WEBSITE' ] );

//---------------------------------------------
// Get timezone from logged in users
//---------------------------------------------

if( $user[ 'user_status' ] )
{
	if( !$user[ 'user_timezone' ] )
	{
		$preferences[ 'website_timezone' ] = $user[ 'user_timezone' ];
	}
}

//---------------------------------------------
// Build canonical link
//---------------------------------------------

$preferences[ 'website_canonical' ] = $preferences[ 'website_url' ];

if( ( !$ct ) and( $preferences[ 'website_seo' ] ) )
{
	$input = $system -> getvariables();

	if( $preferences[ 'website_mod_rewrite' ] and $preferences[ 'website_forcetype' ] )
	{
		if( isset( $input[0]) and isset( $input[1] ) and isset( $input[2] ))
		{
		    if ( $input[0] == "contentteller" )
		    {
		    	$separator = ( $preferences[ 'website_module_separator'] ) ? "/" : "_" ;
				$split = explode( $separator, $input[1] );

				header( "HTTP/1.1 301 Moved Permanently" );
				header( "location: " . $preferences[ 'website_url' ] . "/" . $split[ 0 ] . $separator . $split[ 1 ] . $input[2] );
				exit;
		    }
		}
	}

	if( count( $input ) and $input[ 0 ] )
	{
		if ( $preferences[ 'website_module_separator'] )
		{
			if ( isset( $input[ 0 ] ) )
			{
				$ct = $input[ 0 ];
				if( !$preferences[ 'website_mod_rewrite' ] )
				{
					if ( $preferences[ 'website_forcetype' ] and !$preferences[ 'website_basic_rewrite' ] )
					{
						$preferences[ 'website_canonical' ] .= "/contentteller";
					}
					elseif( $preferences[ 'website_basic_rewrite' ] )
					{
						$preferences[ 'website_canonical' ] .= "/?";
					}
					else
					{
						$preferences[ 'website_canonical' ] .= "/index" . $preferences[ 'param_ext' ];
					}
				}
				$preferences[ 'website_canonical' ] .= $preferences[ 'param_ct' ] . $input[ 0 ];
			}
			else
			{
				$ct = "";

			}

			if ( isset( $input[ 1 ] ) )
			{
				if( $input[ 1 ] != "index.html" )
				{
					$action = $input[ 1 ];
					$preferences[ 'website_canonical' ] .= "/" . $input[ 1 ];
				}
				else
				{
					$action = "";
				}
			}
			else
			{
				$action = "";

			}

			if( isset( $input[ 2 ] ) )
			{
				if( preg_match( "/[A-Z]/i", $security -> checkvar( $input[ 2 ] ) ) )
				{
					$page = $input[ 2 ];
					$canonical_page = ( $preferences[ 'website_seo_hyphens' ] ) ? str_replace( "_", "-", $input[ 2 ] ) : $input[ 2 ] ;
					$preferences[ 'website_canonical' ] .= "/" . $canonical_page;
					$id = 0;
				}
				else
				{
					$page = "";
					$id = $security -> checknum( $input[ 2 ] );
					$preferences[ 'website_canonical' ] .= "/" . $id;
				}
			}
		}
		else
		{
			$ctaction = ( isset( $input[ 0 ] ) ) ? explode( "_", $security -> checkvare( $input[ 0 ] ) ) : "" ;

			if ( isset( $ctaction[ 0 ] ) )
			{
				$ct = $ctaction[ 0 ];
				if( !$preferences[ 'website_mod_rewrite' ] )
				{
					if ( $preferences[ 'website_forcetype' ] and !$preferences[ 'website_basic_rewrite' ] )
					{
						$preferences[ 'website_canonical' ] .= "/contentteller";
					}
					elseif ( $preferences[ 'website_basic_rewrite' ] )
					{
						$preferences[ 'website_canonical' ] .= "/?";
					}
					else
					{
						$preferences[ 'website_canonical' ] .= "/index" . $preferences[ 'param_ext' ];
					}
				}
				$preferences[ 'website_canonical' ] .= $preferences[ 'param_ct' ] . $ctaction[ 0 ];
			}
			else
			{
				$ct = "";

			}

			if ( isset( $ctaction[ 1 ] ) )
			{
				$action = $ctaction[ 1 ];
				$separator = ( $preferences[ 'website_seo_hyphens' ] ) ? "-" : "_" ;
				$preferences[ 'website_canonical' ] .= $separator . $ctaction[ 1 ];
			}
			else
			{
				$ctaction = "";
			}

			if( isset( $input[ 1 ] ) )
			{
				if( $input[ 1 ] )
				{
					if( preg_match( "/[A-Z]/i", $security -> checkvar( $input[ 1 ] ) ) )
					{
						$page = $input[ 1 ];
						$canonical_page = ( $preferences[ 'website_seo_hyphens' ] ) ? str_replace( "_", "-", $input[ 1 ] ) : $input[ 1 ] ;
						$preferences[ 'website_canonical' ] .= "/" . $canonical_page;
						$id = 0;
					}
					else
					{
						$page = "";
						$id = $security -> checknum( $input[ 1 ] );
						$preferences[ 'website_canonical' ] .= "/" . $id;
					}
				}
			}
		}
	 }
}
else
{
	if ( $ct )
	{
		$preferences[ 'website_canonical' ] .= "/index" . $preferences[ 'param_ext' ] . "?ct=" . $ct;
	}
	if ( $action )
	{
		$preferences[ 'website_canonical' ] .= "&action=" . $action;
	}
	if ( $page )
	{
		$preferences[ 'website_canonical' ] .= "&page=" . $page;
	}
	if ( $id )
	{
		$preferences[ 'website_canonical' ] .= "&id=" . $id;
	}
}

if( $preferences[ 'website_charset' ] == "UTF-8" )
{
	$preferences[ 'website_canonical' ] = urldecode( $preferences[ 'website_canonical' ] );
}

//---------------------------------------------
// Website down? Show maintenance message
//---------------------------------------------

if( !$preferences[ 'website_active' ] )
{
	include( "modules/core/websitedown.php" );
	WebsiteDown();
 }

 //---------------------------------------------
// Get post parameters
//---------------------------------------------

if( isset( $_POST[ 'faction' ] ) )
{
	$farray = explode( "_", $_POST[ 'faction' ] );
	$ct = $security -> checkvare( $farray[ 0 ] );
	$action = $security -> checkvare( $farray[ 1 ] );
}

//---------------------------------------------
// Define module
//---------------------------------------------

define( "MODULE", $ct );

//---------------------------------------------
// Generate stats
//---------------------------------------------

if( $preferences[ 'website_stats' ] and !preg_match( "/css|image|javaload|thumb|tasks/i", $action ) )
{
	$system -> stats();
}

//---------------------------------------------
// Load module
//---------------------------------------------

if( !$ct )
{
	include( "modules/" . MAIN_MODULE . "/functions_" . MAIN_MODULE . ".php" );
}
else
{

	if( file_exists( "modules/" . MODULE . "/functions_" . MODULE . ".php" ) )
	{
		include( "modules/" . MODULE . "/functions_" . MODULE . ".php" );
	}
	else
	{
		header( "location: " . $preferences[ 'website_url' ] );
		exit;
	}
}

//---------------------------------------------
// Caching content
//---------------------------------------------

if( isset( $preferences[ 'website_cache_running' ] ) and !preg_match( "/css|image|javaload|thumb|tasks|download|get|search/i", $action ) )
{
	$templates -> writecache();
}

//---------------------------------------------
// Closing the main database connection
//---------------------------------------------

$database -> dbclose();
?>